package de.oaa.xxx.games.common.aufgaben;

import java.util.List;
import java.util.UUID;

import de.oaa.xxx.games.bdsm.GeschlechtEnum;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class Finisher {

    private UUID finisherId;
    private String kurzText;
    private String text;
    private GeschlechtEnum geschlecht;
    private List<Werkzeug> benoetigtAktiv;
    private List<Werkzeug> benoetigtPassiv;
    private List<Toy> benoetigteToys;
    private UUID gruppeId;

    @Override
    public String toString() {
        return "Finisher[id=" + finisherId + ", kurzText=" + kurzText + ", geschlecht=" + geschlecht + ", gruppeId=" + gruppeId + "]";
    }

    public boolean isAufgabePassend(CommonMitspieler aktiv, CommonMitspieler passiv) {
        if (benoetigtPassiv != null) {
            for (Werkzeug werkzeug : benoetigtPassiv) {
                if (!passiv.isVerfuegbar(werkzeug)) {
                    return false;
                }
            }
        }
        if (benoetigtAktiv == null || benoetigtAktiv.isEmpty()) {
            return true;
        } else {
            for (Werkzeug werkzeug : benoetigtAktiv) {
                if (aktiv.isVerfuegbar(werkzeug)) {
                    return true;
                }
            }
            return false;
        }
    }
}
